package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.*;
import java.util.Map;

import com.google.gson.annotations.SerializedName;




/**
 * A generic container for responses from the p4d server that we have yet to completely classify.
 **/
@ApiModel(description = "A generic container for responses from the p4d server that we have yet to completely classify.")
public class CommandResponse   {
  
  @SerializedName("results")
  private List<Map<String, Object>> results = new ArrayList<Map<String, Object>>();
  

  
  /**
   * A collection of maps that have various values set by p4d.
   **/
  @ApiModelProperty(value = "A collection of maps that have various values set by p4d.")
  public List<Map<String, Object>> getResults() {
    return results;
  }
  public void setResults(List<Map<String, Object>> results) {
    this.results = results;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CommandResponse commandResponse = (CommandResponse) o;
    return Objects.equals(this.results, commandResponse.results);
  }

  @Override
  public int hashCode() {
    return Objects.hash(results);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CommandResponse {\n");
    
    sb.append("    results: ").append(toIndentedString(results)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
