package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import com.google.gson.annotations.SerializedName;




/**
 * A persistent variable in the server.
 **/
@ApiModel(description = "A persistent variable in the server.")
public class Counter   {
  
  @SerializedName("counter")
  private String counter = null;
  
  @SerializedName("value")
  private String value = null;
  

  
  /**
   * The variable name
   **/
  @ApiModelProperty(value = "The variable name")
  public String getCounter() {
    return counter;
  }
  public void setCounter(String counter) {
    this.counter = counter;
  }

  
  /**
   * The variable value.\nMany variables are numerical in nature, which allow you to do atomic increment operations in method calls instead of having to fetch, increment, and save.
   **/
  @ApiModelProperty(value = "The variable value.\nMany variables are numerical in nature, which allow you to do atomic increment operations in method calls instead of having to fetch, increment, and save.")
  public String getValue() {
    return value;
  }
  public void setValue(String value) {
    this.value = value;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Counter counter = (Counter) o;
    return Objects.equals(this.counter, counter.counter) &&
        Objects.equals(this.value, counter.value);
  }

  @Override
  public int hashCode() {
    return Objects.hash(counter, value);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Counter {\n");
    
    sb.append("    counter: ").append(toIndentedString(counter)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
