package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;

import com.google.gson.annotations.SerializedName;




@ApiModel(description = "")
public class UsersCommand   {
  
  @SerializedName("user")
  private String user = null;
  
  @SerializedName("type")
  private String type = null;
  
  @SerializedName("email")
  private String email = null;
  
  @SerializedName("update")
  private Date update = null;
  
  @SerializedName("access")
  private Date access = null;
  
  @SerializedName("fullName")
  private String fullName = null;
  
  @SerializedName("hasPassword")
  private String hasPassword = null;
  

  
  /**
   * The Perforce username.
   **/
  @ApiModelProperty(value = "The Perforce username.")
  public String getUser() {
    return user;
  }
  public void setUser(String user) {
    this.user = user;
  }

  
  /**
   * Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.
   **/
  @ApiModelProperty(value = "Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.")
  public String getType() {
    return type;
  }
  public void setType(String type) {
    this.type = type;
  }

  
  /**
   * The user’s email address. By default, this is user@client.
   **/
  @ApiModelProperty(value = "The user’s email address. By default, this is user@client.")
  public String getEmail() {
    return email;
  }
  public void setEmail(String email) {
    this.email = email;
  }

  
  /**
   * The date and time this specification was last updated.
   **/
  @ApiModelProperty(value = "The date and time this specification was last updated.")
  public Date getUpdate() {
    return update;
  }
  public void setUpdate(Date update) {
    this.update = update;
  }

  
  /**
   * The date and time this user last ran a Perforce command.
   **/
  @ApiModelProperty(value = "The date and time this user last ran a Perforce command.")
  public Date getAccess() {
    return access;
  }
  public void setAccess(Date access) {
    this.access = access;
  }

  
  /**
   * The user's full name.
   **/
  @ApiModelProperty(value = "The user's full name.")
  public String getFullName() {
    return fullName;
  }
  public void setFullName(String fullName) {
    this.fullName = fullName;
  }

  
  /**
   * If 'enabled', the password has been set on the user.
   **/
  @ApiModelProperty(value = "If 'enabled', the password has been set on the user.")
  public String getHasPassword() {
    return hasPassword;
  }
  public void setHasPassword(String hasPassword) {
    this.hasPassword = hasPassword;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UsersCommand usersCommand = (UsersCommand) o;
    return Objects.equals(this.user, usersCommand.user) &&
        Objects.equals(this.type, usersCommand.type) &&
        Objects.equals(this.email, usersCommand.email) &&
        Objects.equals(this.update, usersCommand.update) &&
        Objects.equals(this.access, usersCommand.access) &&
        Objects.equals(this.fullName, usersCommand.fullName) &&
        Objects.equals(this.hasPassword, usersCommand.hasPassword);
  }

  @Override
  public int hashCode() {
    return Objects.hash(user, type, email, update, access, fullName, hasPassword);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UsersCommand {\n");
    
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    update: ").append(toIndentedString(update)).append("\n");
    sb.append("    access: ").append(toIndentedString(access)).append("\n");
    sb.append("    fullName: ").append(toIndentedString(fullName)).append("\n");
    sb.append("    hasPassword: ").append(toIndentedString(hasPassword)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
